﻿--[[ Square 2pixel class coloured buttons for Masque ]]--

local MSQ = LibStub("Masque", true)
if not MSQ then
	return
end

--Death Knight
MSQ:AddSkin("CB: 2pixDeathKnight", {
	Author = "jeffy162",
	Version = "1.2.1",
	Shape = "Square",
	Masque_Version = 40200,
	Backdrop = {
		Width = 34,
		height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixDK]],
	},
	Icon = {
		Width = 34,
		Height = 34,
		Texcoords = {0.07, 0.93, 0.07, 0.93},
		},
	Flash = {
		Width = 36,
		Height = 36,
		Color = {1, 0, 0, 0.6},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_overlay]],
	},
	Cooldown = {
		Width = 36,
		Height = 36,
	},
	Pushed = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 0.8},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_pushed]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixDeathKnight]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
	Disabled = {
		Hide = true,
	},
	Checked = {
		Width = 40,
		Height = 40,
		BlendMode = "ADD",
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_checked]],
	},
	Border = {
		Width = 40,
		Height = 40,
		BlendMode = "BLEND",
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_equipped]],
	},
	AutoCastable = {
		width = 40,
		Height = 40,
		Texture = [[Interface\Buttons\UI-AutoCastableOverlay]],
	},
	Highlight = {
		Width = 36,
		Height = 36,
		BlendMode = "ADD",
		Color = {0, 0, 1, 0.9},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_highlight]],
	},
	Gloss = {
		Width = 36,
		Height = 36,
		BlendMode = "ADD",
		Color = {1, 1, 1, 0.5},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_gloss]],
	},
	HotKey = {
		Width = 40,
		Height = 10,
		OffsetX = -6,
		OffsetY = -2,
	},
	Count = {
		Width = 40,
		Height = 10,
		OffsetX = -6,
		OffsetY = 4,
	},
	Name = {
		Width = 40,
		Height = 10,
		OffsetX = 0,
		OffsetY = 4,
	},
	Duration = {
		Width = 40,
		Height = 10,
		OffsetX = 0,
		OffsetY = -10,
	},
	Autocast = {
		Width = 26,
		Height = 26,
		OffsetX = 1,
		OffsetY = -1,
	},
	
}, true)

--Druid
MSQ:AddSkin("CB: 2pixDruid", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixDruid]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixDruid]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Hunter
MSQ:AddSkin("CB: 2pixHunter", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height =34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixHunter]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixHunter]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Mage
MSQ:AddSkin("CB: 2pixMage", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixMage]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixMage]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Monk
MSQ:AddSkin("CB: 2pixMonk", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixMonk]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixMonk]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Paladin
MSQ:AddSkin("CB: 2pixPaladin", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixPaladin]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixPaladin]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Priest
MSQ:AddSkin("CB: 2pixPriest", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixPriest]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixPriest]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Rogue
MSQ:AddSkin("CB: 2pixRogue", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixRogue]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixRogue]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Shaman
MSQ:AddSkin("CB: 2pixShaman", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixShaman]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixShaman]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Warlock
MSQ:AddSkin("CB: 2pixWarlock", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixWarlock]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixWarlock]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)

--Warrior
MSQ:AddSkin("CB: 2pixWarrior", {
	Template = "CB: 2pixDeathKnight",
	Backdrop = {
		Width = 34,
		Height = 34,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\Backdrop_2pixWarrior]],
	},
	Normal = {
		Width = 40,
		Height = 40,
		Color = {1, 1, 1, 1},
		Texture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pixWarrior]],
		EmptyTexture = [[Interface\AddOns\Masque_2pixClassButtons\textures64\2pix_normal]],
	},
}, true)